/*
 * asm.h
 *-
 * Copyright (c) 2001, 2002, 2003 Corrado Santoro (csanto@diit.unict.it)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: asm.h,v 1.1.1.1 2005/05/15 09:49:59 corrado Exp $
 */

#ifndef __ASM_H
#define __ASM_H

#define __cli() __asm__ __volatile__("cli": : :"memory")
#define __sti()	__asm__ __volatile__("sti": : :"memory")
#define __save_flags_cli(c) \
    __asm__ __volatile__("pushf\npop %0\ncli" : : "m" (c))
#define __restore_flags(c)  \
    __asm__ __volatile__("push %0\npopf" : : "m" (c))
#define __halt()    { __cli(); for (;;) ; }
#define __stop()    { for (;;) ; }

#define __getcaller(c) { \
  __asm__ __volatile__ ("push %%eax\n" \
      "movl 4(%%ebp),%%eax\n" \
      "movl %%eax,%0\n" \
      "pop %%eax" : "m=" (c)); }

#endif
