/*
 * basic_printf.h
 *-
 * Copyright (c) 2001, 2002, 2003 Corrado Santoro (csanto@diit.unict.it)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: basic_printf.h,v 1.1.1.1 2005/05/15 09:49:59 corrado Exp $
 */

#ifndef __BASIC_PRINTF_H
#define __BASIC_PRINTF_H

#include <user/ctype.h>
#include <user/stdlib.h>

#define rightpadding(string,size,padchar,char_out,dest) \
{ \
  if ( (size - strlen(string)) > 0) \
  { \
    int i; \
    for (i = 0;i < size - strlen(string);i++) char_out(padchar,dest); \
  } \
}

#define leftpadding(string,size,padchar,char_out,dest) \
{ \
  if ( (size + strlen(string)) < 0) \
  { \
    int i; \
    for (i = 0;i < -(size + strlen(string));i++) char_out(padchar,dest); \
  } \
}

#define __basic_printf(dest,init,char_out,string_out) \
{ \
  char  c,*str,num[64],pad,long_format; \
  int   size,count=0; \
  long  d; \
  init ; \
  while (*fmt) \
  { \
    if (*fmt == '%') \
    { \
      ++fmt; pad = 0; size = 0; long_format = 0;\
      if (isdigit(*fmt) || (*fmt == '-')) \
      { \
        if (*fmt == '0') { pad = '0'; ++fmt; } \
        else pad = ' '; \
        size = strtol(fmt,&fmt,10); \
      } \
      { \
redo: \
        switch (*fmt) \
        { \
          case 'l': \
            long_format = 1; \
            ++fmt; \
            goto redo; \
          case 'c': \
            c = va_arg(ap,int); \
            char_out(c,dest); \
            count++; \
            break; \
          case 's': \
            str = va_arg(ap,char *); \
            rightpadding(str,size,pad,char_out,dest); \
            string_out(str,dest); \
            leftpadding(str,size,pad,char_out,dest); \
            count += strlen(str); \
            break; \
          case 'd': \
            if (long_format) d = va_arg(ap,long); \
            else d = va_arg(ap,int); \
            int_to_string(d,10,num); \
            rightpadding(num,size,pad,char_out,dest); \
            string_out(num,dest); \
            leftpadding(num,size,pad,char_out,dest); \
            count += strlen(num); \
            break; \
          case 'u': \
            if (long_format) d = va_arg(ap,long); \
            else d = va_arg(ap,int); \
            unsigned_int_to_string(d,10,num); \
            rightpadding(num,size,pad,char_out,dest); \
            string_out(num,dest); \
            leftpadding(num,size,pad,char_out,dest); \
            count += strlen(num); \
            break; \
          case 'x': \
            if (long_format) d = va_arg(ap,long); \
            else d = va_arg(ap,int); \
            int_to_string(d,16,num); \
            rightpadding(num,size,pad,char_out,dest); \
            string_out(num,dest); \
            leftpadding(num,size,pad,char_out,dest); \
            count += strlen(num); \
            break; \
          case '%': \
            char_out('%',dest); \
            count++; \
            break; \
          case 0: \
            va_end(ap); \
            return count; \
        } \
      } \
    } \
    else \
    { \
      char_out(*fmt,dest); \
      count++; \
    } \
    fmt++; \
  } \
  va_end(ap); \
  return count; \
}

#endif
