/*
 * device_ioctl.h
 *-
 * Copyright (c) 2001, 2002, 2003 Corrado Santoro (csanto@diit.unict.it)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: device_ioctl.h,v 1.1.1.1 2005/05/15 09:49:59 corrado Exp $
 */

#ifndef __DEVICE_IOCTL_H
#define __DEVICE_IOCTL_H

typedef struct
{
  int block_size;
} t_device_info;

#define IO_GETDEVICEINFO    0

// read/write block for block devices
#define __BLK_WRITE        0x80000000L
#define __BLK_READ         0xc0000000L

#define _IO_BLK_WRITE(b) (__BLK_WRITE | b)
#define _IO_BLK_READ(b)  (__BLK_READ  | b)

#define _IS_BLK_WRITE(c) ((c & __BLK_WRITE) == __BLK_WRITE)
#define _IS_BLK_READ(c)  ((c & __BLK_READ) == __BLK_READ)

#define BLK_NUM(c)       (c & 0x0fffffffl)

#endif

