/*
 * exception.h
 * Copyright (C) 2001 Dario Russo (dariorusso@hotmail.com)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: exception.h,v 1.1.1.1 2005/05/15 09:49:59 corrado Exp $
 */

#ifndef __EXCEPTION_H
#define __EXCEPTION_H

#pragma pack(1)
typedef struct {
  uint32  edi,esi,ebp,esp,ebx,edx,ecx,eax,error_code,eip,cs,eflags;
} t_ex_regs;
#pragma pack()

#define load_regs(regs) \
{ register uint32 * stack; \
  asm ("mov %%ebp,%0" : "=r" (stack) ); \
  regs = (t_ex_regs *)(stack + 7); } 

#define dump_regs(regs) \
  kprintf("EFLAGS = %08lx   CS = %08lx  EIP = %08lx\r\n", \
                          regs->eflags,regs->cs,regs->eip); \
  kprintf("   EAX = %08lx  EBX = %08lx  ECX = %08lx  EDX = %08lx\r\n", \
                          regs->eax,regs->ebx,regs->ecx,regs->edx); \
  kprintf("   ESI = %08lx  EDI = %08lx  EBP = %08lx  ESP = %08lx\r\n", \
                          regs->esi,regs->edi,regs->ebp,regs->esp);

#define dump_stack() \
{ register uint32 * stack; \
  asm ("mov %%ebp,%0" : "=r" (stack) ); \
  stack += 0 ; \
  kprintf("STACK TRACE:\r\n"); \
  for (i = 0;i < 64; i++) \
  { \
    kprintf("%08lx  ",*stack); \
    stack++; \
  } \
  }

void exception_init(void);

#endif
