/*
 * syscall.h
 *-
 * Copyright (c) 2001, 2002, 2003 Corrado Santoro (csanto@diit.unict.it)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: syscall.h,v 1.1.1.1 2005/05/15 09:49:59 corrado Exp $
 */

#ifndef __SYSCALL_H
#define __SYSCALL_H

#include <kernel/task.h>

#define SYSCALL   0x30

void syscall_init(void);

#define SYS_OPEN          0x00
#define SYS_READ          0x01
#define SYS_WRITE         0x02
#define SYS_IOCTL         0x03
#define SYS_FSTAT         0x04
#define SYS_LSEEK         0x05
#define SYS_CLOSE         0x06

#define SYS_FORK          0x10
#define SYS_EXIT          0x11
#define SYS_WAIT          0x12
#define SYS_WAITPID       0x13
#define SYS_GETPID        0x14
#define SYS_GETPPID       0x15
#define SYS_SETPRIORITY   0x16

#define SYS_SLEEP         0x20
#define SYS_USLEEP        0x21


#define SYS_PTHREAD_CREATE  0x30
#define SYS_PTHREAD_JOIN    0x31

#define SYS_SCHED_SETPARAM  0x40

#define PREPARE_CALL(c)     current_task->syscall.syscall_no = c
#define PREPARE_PARAM(p,n)  current_task->syscall.params[p] = n
#define MAKE_CALL           asm ("int $0x30")
#define SYS_RETVAL          current_task->syscall.return_value

#endif
