/*
 * timer.h
 *-
 * Copyright (c) 2001, 2002, 2003 Corrado Santoro (csanto@diit.unict.it)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: timer.h,v 1.1.1.1 2005/05/15 09:49:59 corrado Exp $
 */

#ifndef	__TIMER_H
#define	__TIMER_H

#include <kernel/ntypes.h>
#include <user/sys/time.h>
#include <kernel/task.h>

typedef struct sw_timer
{
  task_struct     * task;
  uint8           skip;
  void            * wait_chan_data;
  struct timeval  wakeup_time;
  struct sw_timer * next;
} sw_timer;

void init_timer(void);
void time_add(struct timeval *result,struct timeval *operand);
void time_diff(struct timeval *result,struct timeval *operand);
int time_compare(struct timeval *op1,struct timeval *op2);
long do_timer(void);
sw_timer * timer_create (unsigned long usecs);
void timer_insert (sw_timer * aux);

/* syscalls */
unsigned int sys_sleep(unsigned int secs);
void sys_usleep(unsigned long usecs);

void check_elapsed_timers(void);

extern uint32  timer_ticks;
extern struct timeval curr_time;

#endif
