/*
 * stdio.h
 *-
 * Copyright (c) 2001, 2002, 2003 Corrado Santoro (csanto@diit.unict.it)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: stdio.h,v 1.1.1.1 2005/05/15 09:50:00 corrado Exp $
 */

#ifndef __STDIO_H
#define __STDIO_H

#include <user/string.h>
#include <user/fcntl.h>
#include <user/stdarg.h>
#include <user/stddef.h>

typedef struct {
  int fid;
} FILE;

int vfprintf(FILE *f,char *fmt,va_list ap);
int printf(char *fmt,...);
int fprintf(FILE *f,char *fmt,...);
int fprintf(FILE *,char *fmt,...);
int fputc(int c,FILE * f);
int fputs(const char *s,FILE * f);
#define putc(c,f)   fputc(c,f)
#define putchar(c)  fputc(c,stdout)
int fgetc(FILE * f);
char * fgets(char * s,int size,FILE * f);
#define getchar()   fgetc(stdin)
#define getc(f)     fgetc(f)

int vsprintf(char *f,char *fmt,va_list ap);
int sprintf(char * f,char *fmt,...);

#define EOF -1

extern FILE * stdout,*stdin, *stderr;

FILE * fopen (const char * path, const char * mode);
size_t fread (void * ptr, size_t size, size_t nmemb, FILE * stream);
size_t fwrite (const void *ptr, size_t size, size_t nmemb, FILE *stream);
int fclose (FILE * stream);
int fseek (FILE *stream, long offset, int whence);
long ftell (FILE * stream);
int fileno (FILE * stream);

#endif
