/*
 * timerdisplay.c
 *-
 * Copyright (c) 2001, 2002, 2003 Corrado Santoro (csanto@diit.unict.it)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: timerdisplay.c,v 1.1.1.1 2005/05/15 09:50:00 corrado Exp $
 */

#include <sys/time.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <kernel/ntypes.h>
#include <kernel/task.h>
extern uint32 timer_ticks;

void * timerdisplay(void * x)
{
  struct timeval tv;
  char  str[80];
  unsigned short *vgamem=(unsigned short*)0xb8000;
  int i;
  signal (1, SIG_IGN);
  //setpriority (PRIO_PROCESS, 0, -1);
  for (;;)
  {
    gettimeofday(&tv,NULL);
    sprintf(str,"%6ld.%06lu",
        tv.tv_sec,tv.tv_usec);
    for (i = 0;i < strlen(str);i++)
      vgamem[i+60] = str[i] + 0x700;
  }
}

void * cpu_time_display(void * x)
{
  struct timeval tv;
  char  str[80];
  unsigned short *vgamem=(unsigned short*)0xb8000;
  int i;
  signal (1, SIG_IGN);
  //setpriority (PRIO_PROCESS, 0, -1);
  for (;;)
  {
    tv = current_task->cpu_time;
    sprintf(str,"%6ld.%06lu",
        tv.tv_sec,tv.tv_usec);
    for (i = 0;i < strlen(str);i++)
      vgamem[i+60+80] = str[i] + 0x700;
  }
}

