/*
 * i8253.c
 *-
 * Copyright (c) 2001, 2002, 2003 Corrado Santoro (csanto@diit.unict.it)
 * Copyright (c) 2002 Dario Russo (dariorusso@hotmail.com)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: i8253.c,v 1.1.1.1 2005/05/15 09:50:01 corrado Exp $
 */
#include <kernel/kprintf.h>
#include <kernel/asm.h>
#define REALLY_SLOW_DOWN_IO
#include <kernel/io.h> 
#include <kernel/interrupt.h>
#include <kernel/kernel.h>
#include <kernel/i8253.h>
#include <kernel/hz.h>

volatile int stoptimer=0;

void stoptimerproc()
{
  stoptimer++;
	outb(0x20,0x20); //riarmo pic??	
}

// read the count register of the selected counter
unsigned int i8253_read(int counter)
{
  unsigned int lo,hi;
  counter &= 3;
  counter <<= 6;
	outb (counter,0x43); // 0x0 latch counter
	SLOW_DOWN_IO;
	lo = inb (0x40+counter);
	SLOW_DOWN_IO;
	hi = inb (0x40+counter);
  return hi * 256 + lo;
}

inline void set_timer_resolution(volatile int resolution)
{
  USEC = 1000000.0*(float)resolution/(float)CLOCK_BASE;
  
  /*kprintf("Timer Resolution is %x, tick duration is %ld usec\n",
      resolution,USEC);*/
  
	outb (0x36,0x43); //00110110b = 0x36
	SLOW_DOWN_IO;
	outb ((resolution & 0xff),0x40);
	SLOW_DOWN_IO;
	outb ((resolution >>8),0x40);
	SLOW_DOWN_IO;
}

inline void set_timer_one_shot(volatile int countdown)
{
	outb (48,0x43); //00110000b = 48
	SLOW_DOWN_IO;
	outb ((countdown & 0xff),0x40);
	SLOW_DOWN_IO;
	outb ((countdown >>8),0x40);
	SLOW_DOWN_IO;
}

inline void i8253_init(void)
{
  /*
  register long mipscounter = 0;
	set_timer_resolution(0);
	register_irq(0,stoptimerproc);
  stoptimer = 0;
  while (stoptimer < 1)
  {
    ++mipscounter;
    asm ("jmp 1f\n1:");
  }
	unregister_irq(0);
	kprintf("Counter reached %ld. Approx Freq = %ld\r\n",
      mipscounter,(mipscounter/182)*40);
  */

	set_timer_resolution(CLOCK_BASE/HZ);
	kprintf("Timers Initialized...");
}

