#
# NUXI Interrupt manager
# Copyright (c) 2001, 2002, 2003 Corrado Santoro (csanto@diit.unict.it)
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES, LOSS OF USE, DATA, OR PROFITS, OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: int.s,v 1.1.1.1 2005/05/15 09:50:01 corrado Exp $
#

.global _load_idtr

  .text
  .code32

  .balign 0x08
_load_idtr:
  lidt  _idtr
  ret

	.balign	0x08
	.word	0x0000
_idtr:	.word	(0x40 * 8)-1
	.long	0x0

.macro INT_HANDLER int_no
1:
  cli 
  pushal
  movl $&int_no,%eax
  pushl %eax
  call interrupt_handler
  addl  $0x4,%esp
  popal
  sti
  iret
  jmp 1b
# this jump is needed since IRET setups EIP of the TSS to the next
# istruction which follows "IRET" itself (see Intel Manual)
.endm
  
_int00_handler: INT_HANDLER 0x0
_int01_handler: INT_HANDLER 0x1
_int02_handler: INT_HANDLER 0x2
_int03_handler: INT_HANDLER 0x3
_int04_handler: INT_HANDLER 0x4
_int05_handler: INT_HANDLER 0x5
_int06_handler: INT_HANDLER 0x6
_int07_handler: INT_HANDLER 0x7
_int08_handler: INT_HANDLER 0x8
_int09_handler: INT_HANDLER 0x9
_int0a_handler: INT_HANDLER 0xa
_int0b_handler: INT_HANDLER 0xb
_int0c_handler: INT_HANDLER 0xc
_int0d_handler: INT_HANDLER 0xd
_int0e_handler: INT_HANDLER 0xe
_int0f_handler: INT_HANDLER 0xf
_int10_handler: INT_HANDLER 0x10
_int11_handler: INT_HANDLER 0x11
_int12_handler: INT_HANDLER 0x12
_int13_handler: INT_HANDLER 0x13
_int14_handler: INT_HANDLER 0x14
_int15_handler: INT_HANDLER 0x15
_int16_handler: INT_HANDLER 0x16
_int17_handler: INT_HANDLER 0x17
_int18_handler: INT_HANDLER 0x18
_int19_handler: INT_HANDLER 0x19
_int1a_handler: INT_HANDLER 0x1a
_int1b_handler: INT_HANDLER 0x1b
_int1c_handler: INT_HANDLER 0x1c
_int1d_handler: INT_HANDLER 0x1d
_int1e_handler: INT_HANDLER 0x1e
_int1f_handler: INT_HANDLER 0x1f
_int20_handler: INT_HANDLER 0x20
_int21_handler: INT_HANDLER 0x21
_int22_handler: INT_HANDLER 0x22
_int23_handler: INT_HANDLER 0x23
_int24_handler: INT_HANDLER 0x24
_int25_handler: INT_HANDLER 0x25
_int26_handler: INT_HANDLER 0x26
_int27_handler: INT_HANDLER 0x27
_int28_handler: INT_HANDLER 0x28
_int29_handler: INT_HANDLER 0x29
_int2a_handler: INT_HANDLER 0x2a
_int2b_handler: INT_HANDLER 0x2b
_int2c_handler: INT_HANDLER 0x2c
_int2d_handler: INT_HANDLER 0x2d
_int2e_handler: INT_HANDLER 0x2e
_int2f_handler: INT_HANDLER 0x2f
_int30_handler: INT_HANDLER 0x30
_int31_handler: INT_HANDLER 0x31
_int32_handler: INT_HANDLER 0x32
_int33_handler: INT_HANDLER 0x33
_int34_handler: INT_HANDLER 0x34
_int35_handler: INT_HANDLER 0x35
_int36_handler: INT_HANDLER 0x36
_int37_handler: INT_HANDLER 0x37
_int38_handler: INT_HANDLER 0x38
_int39_handler: INT_HANDLER 0x39
_int3a_handler: INT_HANDLER 0x3a
_int3b_handler: INT_HANDLER 0x3b
_int3c_handler: INT_HANDLER 0x3c
_int3d_handler: INT_HANDLER 0x3d
_int3e_handler: INT_HANDLER 0x3e
_int3f_handler: INT_HANDLER 0x3f

.global _int00_handler
.global _int01_handler
.global _int02_handler
.global _int03_handler
.global _int04_handler
.global _int05_handler
.global _int06_handler
.global _int07_handler
.global _int08_handler
.global _int09_handler
.global _int0a_handler
.global _int0b_handler
.global _int0c_handler
.global _int0d_handler
.global _int0e_handler
.global _int0f_handler
.global _int10_handler
.global _int11_handler
.global _int12_handler
.global _int13_handler
.global _int14_handler
.global _int15_handler
.global _int16_handler
.global _int17_handler
.global _int18_handler
.global _int19_handler
.global _int1a_handler
.global _int1b_handler
.global _int1c_handler
.global _int1d_handler
.global _int1e_handler
.global _int1f_handler
.global _int20_handler
.global _int21_handler
.global _int22_handler
.global _int23_handler
.global _int24_handler
.global _int25_handler
.global _int26_handler
.global _int27_handler
.global _int28_handler
.global _int29_handler
.global _int2a_handler
.global _int2b_handler
.global _int2c_handler
.global _int2d_handler
.global _int2e_handler
.global _int2f_handler
.global _int30_handler
.global _int31_handler
.global _int32_handler
.global _int33_handler
.global _int34_handler
.global _int35_handler
.global _int36_handler
.global _int37_handler
.global _int38_handler
.global _int39_handler
.global _int3a_handler
.global _int3b_handler
.global _int3c_handler
.global _int3d_handler
.global _int3e_handler
.global _int3f_handler

  .end
