/*
 * process.c
 *-
 * Copyright (c) 2001, 2002, 2003 Corrado Santoro (csanto@diit.unict.it)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: process.c,v 1.1.1.1 2005/05/15 09:50:01 corrado Exp $
 */

#include <kernel/ntypes.h>
#include <kernel/task.h>
#include <kernel/errno.h>
#include <kernel/syscall.h>
#include <user/sys/types.h>


// FIXME! IMPLEMENT FORK AS SYSTEM CALL!
/*
pid_t sys_fork (void);

pid_t fork (void)
{
  //PREPARE_CALL(SYS_FORK);
  //MAKE_CALL;
  //return SYS_RETVAL;
  return sys_fork ();
}
*/

void exit(int status)
{
  PREPARE_CALL(SYS_EXIT);
  PREPARE_PARAM (0, (uint32) status);
  MAKE_CALL;
}

pid_t wait (int * status)
{
  PREPARE_CALL(SYS_WAIT);
  PREPARE_PARAM (0, (uint32) status);
  MAKE_CALL;
  return SYS_RETVAL;
}

// FIXME! Manage options
pid_t waitpid (pid_t wpid, int * status, int options)
{
  PREPARE_CALL(SYS_WAITPID);
  PREPARE_PARAM (0, (uint32) wpid);
  PREPARE_PARAM (1, (uint32) status);
  PREPARE_PARAM (2, (uint32) options);
  MAKE_CALL;
  return SYS_RETVAL;
}

pid_t getpid(void)
{
  PREPARE_CALL(SYS_GETPID);
  MAKE_CALL;
  return SYS_RETVAL;
}

pid_t getppid(void)
{
  PREPARE_CALL(SYS_GETPPID);
  MAKE_CALL;
  return SYS_RETVAL;
}
