/*
 * pthread.c
 * NUXI POSIX THREAD IMPLEMENTATION (user side)
 *-
 * Copyright (c) 2001, 2002, 2003 Corrado Santoro (csanto@diit.unict.it)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: pthread.c,v 1.1.1.1 2005/05/15 09:50:01 corrado Exp $
 */

#include <kernel/syscall.h>
#include <user/pthread.h>

int pthread_create(pthread_t * pt,pthread_attr_t * pa,
                void * (*start_routine)(void*),void * arg)
{
  PREPARE_CALL (SYS_PTHREAD_CREATE);
  PREPARE_PARAM (0, (uint32) pt);
  PREPARE_PARAM (1, (uint32) pa);
  PREPARE_PARAM (2, (uint32) start_routine);
  PREPARE_PARAM (3, (uint32) arg);
  MAKE_CALL;
  return 0;
}

int pthread_join (pthread_t thread, void ** value_ptr)
{
  PREPARE_CALL (SYS_PTHREAD_JOIN);
  PREPARE_PARAM (0, (uint32) &thread);
  PREPARE_PARAM (1, (uint32) value_ptr);
  MAKE_CALL;
  return 0;
}

