/*
 * dir.h
 * Copyright (C) 2001,2002 Corrado Santoro (csanto@diit.unict.it)
 *
 *   The contents of this file are subject to the GNU Public License
 *   (the "License"); you may not use this file except in compliance with
 *   the License. You may obtain a copy of the License at http://www.fsf.org.
 *
 *   Software distributed under the License is distributed on an "AS IS"
 *   basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *   License for the specific language governing rights and limitations
 *   under the License.
 *
 *   The Original Code is NUXI code.
 *
 *   The Initial Developer of the Original Code is Corrado Santoro.
 *   Portions created by Corrado Santoro are Copyright (C) 2001,2002.
 *   All Rights Reserved.
 */

#ifndef __DIR_H
#define __DIR_H

#include <kernel/ntypes.h>
#include <kernel/file.h>
#include <kernel/wait.h>


typedef struct t_dirent
{
  struct t_dirent * next;
  char  name[MAX_FILENAME+1];
  int   type;
  char  mark;
  long  size;
  void  * reference;
} t_dirent;


typedef struct
{
  t_dirent * head;
  t_semaphore mutex;
} t_dir;

t_dir * dir_new (void);
t_dirent * dir_create (t_dir * d, char * name, int type);
t_dirent * dir_find (t_dir * d, char * name);
t_dirent * dir_scan (t_dir * d, t_dirent * ds);
void dir_mark (t_dir * d, t_dirent * ds);
void dir_destroy (t_dir * d);

#endif
