/*
 * rpc.h
 * Copyright (C) 2001,2002 Corrado Santoro (csanto@diit.unict.it)
 */

#ifndef __RPC_H
#define __RPC_H

#include <kernel/mailbox.h>

typedef uint32 (*rpc_proc)(uint32 *);

typedef struct {
  char * name;
  rpc_proc proc;
} t_rpc;

typedef struct {
  int svr_id;
  char * name;
  int nprocs;
  t_rpc *procs;
  uint32 task_id;
  t_semaphore mutex;
} t_rpc_server;

typedef struct t_rpc_svr_list {
  t_rpc_server server;
  struct t_rpc_svr_list * next;
} t_rpc_svr_list;

#endif
