/*
 * user_main.c
 * Copyright (C) 2001, 2002 Corrado Santoro (csanto@diit.unict.it)
 */

#include <kernel/console.h>
#include <kernel/kprintf.h>
#include <kernel/wait.h>
#include <kernel/mailbox.h>
#include <user/pthread.h>
#include <user/stdio.h>

wait_chan w1 = NULL,w2 = NULL,w3 = NULL;
void spinner(int progress,int task)
{
	switch ( progress)
	{
		case 0:
			console_memput(task,24,'-',7);
		case 1:
			console_memput(task,24,'/',7);
		case 2:
			console_memput(task,24,'|',7);
		case 3:
			console_memput(task,24,'\\',7);
	}
			
}
void * fourth_task(void * x)
{
  unsigned char c;
  int i = 0;
  kprintf("%s Task Started.\r\n",x);
  /*
  print_mem_space(); kprintf("---\r\n");
  p1 = kmalloc(2048); print_mem_space(); kprintf("---\r\n");
  p2 = kmalloc(5000); print_mem_space(); kprintf("---\r\n");
  kfree(p1); print_mem_space(); kprintf("---\r\n");
  p1 = kmalloc(2000); print_mem_space(); kprintf("---\r\n");
  p3 = kmalloc(2000); print_mem_space(); kprintf("---\r\n");
  kfree(p2); print_mem_space(); kprintf("---\r\n");
  kfree(p1); print_mem_space(); kprintf("---\r\n");
  kfree(p3); print_mem_space(); kprintf("---\r\n");
  */
  c = 0;
  for (;;) {
	spinner(c,4);
    c++;
    if (c >= 4) {
      c = 0;
    }
  /*  if (i++ > 1000000) {
      wakeup(&w1);
      sleep(&w3);
      i = 0;
    }
 */ }
}


void * third_task(void * x)
{
  unsigned char c;
  int i=0;
  kprintf("%s Task Started.\r\n",x);
  c = 0;
//  sleep(&w2);
  for (;;) {
	spinner(c,3);

    //wakeup(&w1);
//    kprintf("Third %d ",c);
    c++;
    if (c >= 4) {
      c = 0;
    }
 /*   if (i++ > 1000000) {
      wakeup(&w3);
      sleep(&w2);
      i = 0;
    }
 */ }
}

void * second_task(void * x)
{
  unsigned char c;
  int i=0;
  printf("%s Task Started.\n",x);
  c = 0;
//  sleep(&w1);
  for (;;) {
	spinner(c,2);

    c++;
    if (c >= 4) {
      c = 0;
    }
  /*  if (i++ > 1000000) {
      wakeup(&w2);
      sleep(&w1);
      i = 0;
    }
 */ }
}

t_semaphore sem   = INIT_NEW_SEMAPHORE(1);
t_semaphore empty = INIT_NEW_SEMAPHORE(10);
t_semaphore full  = INIT_NEW_SEMAPHORE(0);

#define DELAY 200000

void * aproducer(void * x)
{
  int i;
  while (1)
  {
    semaphore_down(&empty);
    semaphore_down(&sem);
    kprintf("Produce ");
    semaphore_up(&sem);
    semaphore_up(&full);
    for (i = 0;i < DELAY/4;i++);
  }
}

void * aconsumer(void * x)
{
  int i;
  while (1)
  {
    semaphore_down(&full);
    semaphore_down(&sem);
    kprintf("Consume ");
    semaphore_up(&sem);
    semaphore_up(&empty);
    for (i = 0;i < DELAY;i++);
  }
}

void thecons(int mbox_num,t_mailbox_message * msg)
{
  kprintf("Cons..");
}

void * producer(void * x)
{
  int i;
  t_mailbox_message msg;
  for (i = 0;i < DELAY*8;i++);
  mailbox_create(1);
  //mailbox_set_async(1,thecons);
  while (1)
  {
    printf("Produce ");
    mailbox_send(1,&msg);
    for (i = 0;i < DELAY/2;i++);
  }
}

void * consumer(void * x)
{
  int i;
  t_mailbox_message msg;
  //for(;;);
  printf("Wait.. ");
  mailbox_connect(1);
  printf("Ok.. ");
  //for (i = 0;i < DELAY*8;i++);
  while (1)
  {
    printf("Consume ");
    mailbox_receive(1,&msg);
    for (i = 0;i < DELAY;i++);
  }
}

void * shell(void * x)
{
  int i;
  char  s[80];
  printf("\n\n****** NUXI Shell *******\n\n");
  while (1)
  {
    printf("nuxi$ ");
    fgets(s,80,stdin);
    if (strlen(s) > 0) 
    {
      if (!strcmp(s,"clear")) printf("\014");
      else printf("You typed: '%s'\n",s);
    }
  }
}

