/*
 * dirent.c
 * Copyright (C) Corrado Santoro (csanto@diit.unict.it)
 *
 *   The contents of this file are subject to the GNU Public License
 *   (the "License"); you may not use this file except in compliance with
 *   the License. You may obtain a copy of the License at http://www.fsf.org.
 *
 *   Software distributed under the License is distributed on an "AS IS"
 *   basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *   License for the specific language governing rights and limitations
 *   under the License.
 *
 *   The Original Code is NUXI code.
 *
 *   The Initial Developer of the Original Code is Corrado Santoro.
 *   Portions created by Corrado Santoro are Copyright (C) 2001,2002.
 *   All Rights Reserved.
 */

#ifndef __DIRENT_H
#define __DIRENT_H

#include <kernel/ntypes.h>
#include <kernel/file.h>

struct dirent
{
  char  d_name [MAX_FILENAME+1];
};

struct dirent_element
{
  struct dirent * d;
  struct dirent_element * next;
};

typedef struct
{
  struct dirent * head, * pos;
  void * data;
} DIR;

DIR * opendir(const char * name);
struct dirent * readdir(DIR * dir);
int closedir(DIR * dir);

#endif

