/*
 * kernelsize.c
 * Compute kernel size and place the number of sectors to load in the
 * boot sector
 * Copyright (C) 2001,2002 Corrado Santoro (csanto@diit.unict.it)
 *
 * $Id: kernelsize.c,v 1.1.1.1 2005/05/15 09:50:03 corrado Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

int main(int argc,char *argv[])
{
  int f;
  long size;
  int i;
  unsigned char c;
  short sectors;
  long filler_size;
  if (argc != 2) {
    fprintf(stderr,"usage: %s imagefile\n",argv[0]);
    exit(1);
  }
  f = open(argv[1],O_RDWR);
  if (f < 0) {
    perror ("open");
    exit(1);
  }
  size = lseek(f,0,SEEK_END);
  sectors = (size - 512) / 512 + 1;
  printf("Kernel is %ld bytes, %d sectors\n",size,sectors);
  lseek(f,2,SEEK_SET);
  write(f,(char*)&sectors,sizeof (short));
  lseek(f,0,SEEK_END);
  filler_size = size % 512;
  c = 0;
  while (filler_size > 0) {
    write(f,&c,1);
    --filler_size;
  }
  close(f);
}
